//package com.example.funbunnyflutter;
package com.basemimo.agora_rtc.agora_rtc;

import android.app.Application;
import android.content.Context;
import android.util.Log;

import androidx.annotation.NonNull;

//import com.example.funbunnyflutter.rtc.RtcVideoManagerHolder;
//import com.faceunity.nama.FURenderer;

import com.basemimo.agora_rtc.agora_rtc.Faceunity.FURenderer;

import java.util.HashMap;
import java.util.Map;

import io.agora.capture.video.camera.CameraVideoManager;
import io.agora.capture.video.camera.Constant;
import io.flutter.plugin.common.BinaryMessenger;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;

public class FUManagrePlugin  implements MethodChannel.MethodCallHandler  {
    public static String CHANNEL = "plugins.faceunity.io";
    static MethodChannel channel;
    private Context  applicationContext ;

    public void registerWith( BinaryMessenger messages, Context context) {
        Log.w("onMethodCall", "registerWith:");
        applicationContext = context;
        channel = new MethodChannel(messages, CHANNEL);
        channel.setMethodCallHandler(this);

    }


    @Override
    public void onMethodCall(@NonNull MethodCall call, @NonNull MethodChannel.Result result) {
        String methodName = call.method;
        Map arguments = (Map)call.arguments;
        String callName = (String) ((Map) call.arguments).get("call");
        Map params = (Map)arguments.get("params");

        Log.w("FCManagrePlugin", "onMethodCall: " + call.method + call.arguments);
        HashMap resultMap = new HashMap();
        resultMap.put("errorCode","0");
        if (methodName.equals("FLClientFaceUnity")) {

            if (callName.equals("buildFaceUnity")) {

                FURenderer.setup(applicationContext,params.get("key").toString());

                RtcVideoManagerHolder.mVideManager = new CameraVideoManager(applicationContext,
                        new PreprocessorFaceUnity(applicationContext));
                RtcVideoManagerHolder.mVideManager.enablePreprocessor(true);
                RtcVideoManagerHolder.mVideManager.setPictureSize(1280, 720);
                RtcVideoManagerHolder.mVideManager.setFrameRate(24);
                RtcVideoManagerHolder.mVideManager.setFacing(Constant.CAMERA_FACING_FRONT);
                RtcVideoManagerHolder.mVideManager.setLocalPreviewMirror(Constant.MIRROR_MODE_AUTO);

                
                if (FURenderer.sIsInited) {

                    HashMap dataMap = new HashMap();
                    dataMap.put("errorCode","0");
                    HashMap dataMapResult = new HashMap();
                    dataMapResult.put("isSuccess","1");
                    dataMap.put("results",dataMapResult);
                    result.success(dataMap);
                } else {
                    HashMap dataMap = new HashMap();
                    dataMap.put("errorCode","-1");
                    HashMap dataMapResult = new HashMap();
                    dataMapResult.put("error","build faceunity fail");
                    dataMap.put("results",dataMapResult);
                    result.success(dataMap);
                }
            } else if (callName.equals("stopCapture")) {
                if (RtcVideoManagerHolder.mFURenderer != null) {
                    RtcVideoManagerHolder.mFURenderer.stopCapture();
                    RtcVideoManagerHolder.mFURenderer.onSurfaceDestroyed();
                }
                HashMap dataMap = new HashMap();
                dataMap.put("errorCode","0");
                HashMap dataMapResult = new HashMap();
                dataMapResult.put("isSuccess","1");
                dataMap.put("results",dataMapResult);
                result.success(dataMap);
//                startCaptureOnSurfaceCreated
            } else if (callName.equals("startCaptureOnSurfaceCreated")) {
                if (RtcVideoManagerHolder.mVideManager != null && RtcVideoManagerHolder.mFURenderer != null) {
                    RtcVideoManagerHolder.mVideManager.startCapture();
                    RtcVideoManagerHolder.mFURenderer.onSurfaceCreated();
                }
                HashMap dataMap = new HashMap();
                dataMap.put("errorCode","0");
                HashMap dataMapResult = new HashMap();
                dataMapResult.put("isSuccess","1");
                dataMap.put("results",dataMapResult);
                result.success(dataMap);
            } else if (callName.equals("isBuildSuccess")) {
                HashMap dataMap = new HashMap();
                dataMap.put("errorCode","0");
                HashMap dataMapResult = new HashMap();
                dataMapResult.put( "isSuccess",RtcVideoManagerHolder.mFURenderer.sIsInited ?"1" : "0");
                dataMap.put("results",dataMapResult);
                result.success(dataMap);
            } else if (callName.equals("switchCamera")) {
                RtcVideoManagerHolder.mVideManager.switchCamera();
                HashMap dataMap = new HashMap();
                dataMap.put("errorCode","0");
                HashMap dataMapResult = new HashMap();
                dataMapResult.put( "isSuccess","1" );
                dataMap.put("results",dataMapResult);
                result.success(dataMap);
            }  else if (callName.equals("setVideoMirrored")) {
                String mirror = (String)params.get("mirror");
                RtcVideoManagerHolder.mVideManager.setLocalPreviewMirror(mirror.equals("1") ? 1 : 0);
                HashMap dataMap = new HashMap();
                dataMap.put("errorCode","0");
                HashMap dataMapResult = new HashMap();
                dataMapResult.put( "isSuccess","1" );
                dataMap.put("results",dataMapResult);
                result.success(dataMap);
            } else
             if (callName.equals("setSkinBeautyParam") || callName.equals("setFacialBeautyParam") || callName.equals("setFliterBeautyParam")) {
                String name = params.get("name").toString();
                float intensity = Float.parseFloat(params.get("value").toString());
                if (FURenderer.sIsInited) {
                    RtcVideoManagerHolder.mFURenderer.setBeautyParameter(name,intensity);
                    HashMap dataMap = new HashMap();
                    dataMap.put("errorCode","0");
                    HashMap dataMapResult = new HashMap();
                    dataMapResult.put("isSuccess","1");
                    dataMap.put("results",dataMapResult);
                    result.success(dataMap);
                } else {
                    HashMap dataMap = new HashMap();
                    dataMap.put("errorCode","-1");
                    HashMap dataMapResult = new HashMap();
                    dataMapResult.put("error","build faceunity fail");
                    dataMap.put("results",dataMapResult);
                    result.success(dataMap);
                }

            } else if (callName.equals("changeBeautyParam")) {
                String name = params.get("name").toString();
                int type = (int)params.get("type");
                float intensity = Float.parseFloat(params.get("value").toString());
                if (FURenderer.sIsInited) {
                    if (type == 2) {
                        RtcVideoManagerHolder.mFURenderer.setStickerModuleParameter(name);
                    } else if (type == 0) {
                        if (name.equals("blur_level")) {
                            RtcVideoManagerHolder.mFURenderer.setBeautyParameter(name, intensity * 6);
                        } else {
                            RtcVideoManagerHolder.mFURenderer.setBeautyParameter(name, intensity);
                        }

                    } else if (type == 3) {
                        RtcVideoManagerHolder.mFURenderer.setMakrupModuleParameter(name);
                    } else if (type == 4) {
                        RtcVideoManagerHolder.mFURenderer.setBeautyBodyParameter(name, intensity);
                    } else if (type == 1) {
                        RtcVideoManagerHolder.mFURenderer.setBeautyParameter(name, intensity);
                    }
                    HashMap dataMap = new HashMap();
                    dataMap.put("errorCode","0");
                    HashMap dataMapResult = new HashMap();
                    dataMapResult.put("isSuccess","1");
                    dataMap.put("results",dataMapResult);
                    result.success(dataMap);
                } else {
                    HashMap dataMap = new HashMap();
                    dataMap.put("errorCode","-1");
                    HashMap dataMapResult = new HashMap();
                    dataMapResult.put("error","build faceunity fail");
                    dataMap.put("results",dataMapResult);
                    result.success(dataMap);
                }
            } else if (callName.equals("dealloc")) {
                 RtcVideoManagerHolder.mFURenderer.deallocCapturerManager();
                HashMap dataMap = new HashMap();
                dataMap.put("errorCode","0");
                HashMap dataMapResult = new HashMap();
                dataMapResult.put("isSuccess","1");
                dataMap.put("results",dataMapResult);
                result.success(dataMap);
            }

        } else {
            result.notImplemented();
        }

    }
}
