package com.basemimo.agora_rtc.agora_rtc.Faceunity.module.event;

import android.util.Log;

import com.basemimo.agora_rtc.agora_rtc.Faceunity.utils.LogUtils;
import com.faceunity.wrapper.faceunity;

import java.util.ArrayList;

/**
 * @author Richie on 2020.07.07
 */
public class RenderEventQueue {
    private static final String TAG = "RenderEventQueue";
    private final ArrayList<Runnable> mEventQueue = new ArrayList<>(16);

    public void add(final Runnable runnable) {
        synchronized (this) {
            mEventQueue.add(runnable);
        }
    }

    public void addItemSetParamEvent(final int itemHandle, final String key, final Object value) {
        if (itemHandle <= 0 || key == null || key.length() == 0 || value == null) {
            return;
        }
        synchronized (this) {
            mEventQueue.add(new Runnable() {
                @Override
                public void run() {
                    LogUtils.verbose(TAG, "fuItemSetParam. itemHandle: %d, key: %s, value: %s", itemHandle, key, value);
                   int count = 0;
                    if (value instanceof Float) {
                        count = faceunity.fuItemSetParam(itemHandle, key, (Float) value);
                    } else if (value instanceof Double) {
                        count = faceunity.fuItemSetParam(itemHandle, key, (Double) value);
                    } else if (value instanceof Integer) {
                        count = faceunity.fuItemSetParam(itemHandle, key, (Integer) value);
                    } else if (value instanceof String) {
                        count = faceunity.fuItemSetParam(itemHandle, key, (String) value);
                    } else if (value instanceof double[]) {
                        count = faceunity.fuItemSetParam(itemHandle, key, (double[]) value);
                    }
//                    Log.d()
                    Log.d("##############", String.valueOf(count) +"     key" + key);
                }
            });
        }
    }


    public void executeAndClear() {
        synchronized (this) {
            while (!mEventQueue.isEmpty()) {
                mEventQueue.remove(0).run();
            }
        }
    }

    public void clear() {
        synchronized (this) {
            mEventQueue.clear();
        }
    }

}
