//
//  FUManagrePlugin.m
//  Runner
//
//  Created by mac on 2021/5/24.
//

#import "FUManagrePlugin.h"
#import "FUManager.h"
#import <libCNamaSDK/CNamaSDK.h>
//#import ""
static FUManagrePlugin *manager = nil;

@interface FUManagrePlugin ()


@end
@implementation FUManagrePlugin

+ (instancetype)shareManager:(NSObject<FlutterPluginRegistrar> *)registrar {
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        manager = [[FUManagrePlugin alloc] init:registrar];
    });
    return manager;
}

- (instancetype)init:(NSObject<FlutterPluginRegistrar> *)registrar
{
    self = [super init];
    if (self) {
//            [_eventChannel setStreamHandler:self];
//        }
    }
    return self;
}



+(void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar> *)registrar {
    
    FlutterMethodChannel *channel = [FlutterMethodChannel methodChannelWithName:@"plugins.faceunity.io" binaryMessenger:[registrar messenger]];
    FUManagrePlugin *fcService = [FUManagrePlugin shareManager:registrar];
    [registrar addMethodCallDelegate:fcService channel:channel];
    [FUManager shareManager];
}

- (void)handleMethodCall:(FlutterMethodCall *)call result:(FlutterResult)result {
    NSString *methodName = call.method;
    NSDictionary *callArguments = call.arguments;
    NSString *callName = callArguments[@"call"];
    NSDictionary *params = callArguments[@"params"];
    if ([methodName isEqualToString:@"FLClientFaceUnity"] ) {
        if ([callName isEqualToString:@"buildFaceUnity"] ) {
            
            NSString *key = params[@"key"];
            int count = [[FUManager shareManager] buildFaceUnity:key];
            if (count > 0) {
                result(@{
                         @"errorCode": @"0",
                         @"results": @{
                                 @"isSuccess":@(count)
                         }
                        });
            } else {
                result(@{
                         @"errorCode": @"-1",
                         @"results": @{
                                 @"error":@"build faceunity fail"
                         }
                        });
            }
            
        } else if ([callName isEqualToString:@"dealloc"]) {
            [[FUManager shareManager] deallocCapturerManager];
            result(@{
                     @"errorCode": @"0",
                     @"results": @{
                             @"isSuccess":@"1"
                     }
                    });
//            stopCapture
        } else if ([callName isEqualToString:@"stopCapture"]) {
            [[FUManager shareManager] stopCapture];
            result(@{
                     @"errorCode": @"0",
                     @"results": @{
                             @"isSuccess":@"1"
                     }
                    });
//            stopCapture
        } else if ([callName isEqualToString:@"isBuildSuccess"]) {
            result(@{
                     @"errorCode": @"0",
                     @"results": @{
                             @"isSuccess":[FUManager shareManager].isInit ?  @"1" : @"0"
                     }
                    });
        } else if ([callName isEqualToString:@"switchCamera"]) {
//            [[FUManager shareManager] deallocCapturerManager];
            [[FUManager shareManager].capturerManager switchCamera];
            result(@{
                     @"errorCode": @"0",
                     @"results": @{
                             @"isSuccess":@"1"
                     }
                    });
//            dealloc
        } else if ([callName isEqualToString:@"setVideoMirrored"]) {
            NSString *mirror = params[@"mirror"];
            [[FUManager shareManager].capturerManager setVideoMirrored:[mirror isEqualToString:@"1"] ? true : false];
            
        } else {
            FUBeautyParam *param = [[FUBeautyParam alloc] init];
            param.mParam = params[@"name"];
            param.type = [params[@"type"] intValue];
            param.mValue = [params[@"value"] floatValue];
            NSLog(@"%@",param.mParam);
            if ([callName isEqualToString:@"setSkinBeautyParam"] ) {
                
                if ([FUManager shareManager].isInit == false) {
                    result(@{
                             @"errorCode": @"-1",
                             @"results": @{
                                     @"error":@"build faceunity fail"
                             }
                            });
                    return;
                }
                int count = [[FUManager shareManager] setBeautyParameter:param];

                result(@{
                         @"errorCode": @"0",
                         @"results": @{
                                 @"isSuccess":@(count)
                         }
                        });
        }  else if ([callName isEqualToString:@"setFacialBeautyParam"]) {
            if ([FUManager shareManager].isInit == false) {
                result(@{
                         @"errorCode": @"-1",
                         @"results": @{
                                 @"error":@"build faceunity fail"
                         }
                        });
                return;
            }
            int count = [[FUManager shareManager] setFacialParameter:param];
            result(@{
                     @"errorCode": @"0",
                     @"results": @{
                             @"isSuccess":@(count)
                     }
                    });
        } else if ([callName isEqualToString:@"setFliterBeautyParam"]) {
            if ([FUManager shareManager].isInit == false) {
                result(@{
                         @"errorCode": @"-1",
                         @"results": @{
                                 @"error":@"build faceunity fail"
                         }
                        });
                return;
            }
            int count = [[FUManager shareManager] setFliterParameter:param];
            result(@{
                     @"errorCode": @"0",
                     @"results": @{
                             @"isSuccess":@(count)
                     }
                    });
        }  else if ([callName isEqualToString:@"changeBeautyParam"]) {
            if ([FUManager shareManager].isInit == false) {
                result(@{
                         @"errorCode": @"-1",
                         @"results": @{
                                 @"error":@"build faceunity fail"
                         }
                        });
                return;
            }
             [[FUManager shareManager] filterValueChange:param];
            result(@{
                     @"errorCode": @"0",
                     @"results": @{
                             @"isSuccess":@"1"
                     }
                    });
        }
        }
    } else {
        result(@{
                 @"errorCode": @"-1",
                 @"results": @{
                         @"reason":FlutterMethodNotImplemented
                 }
                });
    }
    
//    });

    
}


@end
