import 'package:agora_rtc/FUManager/FUConfig.dart';
import 'package:flutter/services.dart';

class FUManager {
  static const MethodChannel _methodChannel =
      const MethodChannel('plugins.faceunity.io');

  static Future<dynamic> callMethodForFaceUnity(String name, Map arguments) {
    return _methodChannel
        .invokeMethod("FLClientFaceUnity", {"call": name, "params": arguments});
  }

  static Future<dynamic> buildFaceUnity(String key) async {
    final res = await callMethodForFaceUnity("buildFaceUnity", {
      "key": key,
    });
    return res;
  }

  static Future<dynamic> setSkinBeautyParam(FUBeautyParam param) async {
    final res = await callMethodForFaceUnity("setSkinBeautyParam", {
      "name": param.mParam,
      "value": param.mValue.toString(),
      "type": param.type
    });
    return res;
  }

  static Future<dynamic> setFacialBeautyParam(FUBeautyParam param) async {
    final res = await callMethodForFaceUnity("setFacialBeautyParam", {
      "name": param.mParam,
      "value": param.mValue.toString(),
      "type": param.type
    });
    return res;
  }

  // static Future<dynamic> setBeautifyBodyBeautyParam(FUBeautyParam param) async {
  //   final res = await callMethodForFaceUnity("setBeautifyBodyBeautyParam", {"name":param.mParam,"value":param.mValue.toString(),"type":param.type});
  //   return res;
  // }

  static Future<dynamic> setFliterBeautyParam(FUBeautyParam param) async {
    final res = await callMethodForFaceUnity("setFliterBeautyParam", {
      "name": param.mParam,
      "value": param.mValue.toString(),
      "type": param.type
    });
    return res;
  }

  static Future<dynamic> changeBeautyParam(FUBeautyParam param) async {
    final res = await callMethodForFaceUnity("changeBeautyParam", {
      "name": param.mParam,
      "value": param.mValue.toString(),
      "type": param.type
    });
    return res;
  }

  static Future<dynamic> stopCapture() async {
    final res = await callMethodForFaceUnity("stopCapture", {});
    return res;
  }

//  only android // startCapture
  static Future<bool> startCaptureOnSurfaceCreated() async {

    final res = await callMethodForFaceUnity("startCaptureOnSurfaceCreated", {});
    return res['results']['isSuccess'] == "1";
    // return res;
  }

  // switchCamera
  static Future<dynamic> switchCamera() async {
    final res = await callMethodForFaceUnity("switchCamera", {});
    return res;
  }

  static Future<bool> isBuild() async {
    final res = await callMethodForFaceUnity("isBuildSuccess", {});
    return res['results']['isSuccess'] == "1";
  }

  static Future<dynamic> setVideoMirrored(bool mirror) async {
    final res = await callMethodForFaceUnity(
        "setVideoMirrored", {"mirror": mirror ? "1" : "0"});
    return res;
  }

  static Future<bool> deallocFaceUnity() async {
    final res = await callMethodForFaceUnity("dealloc", {});
    return res['results']['isSuccess'] == "1";
  }
}
